using System;
using System.Drawing;
using System.Collections;

// ABB namespaces
using ABB.Robotics.Controllers;
using ABB.Robotics.Tps.Taf;
using ABB.Robotics.Tps.Windows.Forms;

// Compliance Tool Info 
[assembly: TpsView("SignalBindingSample", "tpu-Operator32.gif", "tpu-Operator16.gif", "TpsViewIRC5SignalSample.dll", "TpsViewIRC5SignalSample.TpsViewIRC5SignalSample", StartPanelLocation.Left, TpsViewType.Static, TpsViewStartupTypes.Manual)]
namespace TpsViewIRC5SignalSample
{
    /// <summary>
    /// Summary description for TpsViewIRC5App1.
    /// </summary>
    public class TpsViewIRC5SignalSample : TpsForm, ITpsViewSetup, ITpsViewActivation
    {
        private System.Windows.Forms.DataGrid dataGrid1;
        private Button _btnOff;
        private Button _btnOn;
        private System.Windows.Forms.Label label3;
        private System.Windows.Forms.Label label2;
        private System.Windows.Forms.Label label1;
        private GroupBox groupBox1;

        private ABB.Robotics.DataBinding.SignalObject _tempObj = null;
        private ABB.Robotics.DataBinding.SignalBindingSource signalBindingSource1;
        private System.Windows.Forms.DataGridTableStyle dataGridTableStyle1;

        public TpsViewIRC5SignalSample()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();
            label3.Text = signalBindingSource1.Count.ToString();

            //
            // ToDo: Add any constructor code after InitializeComponent call
            //
        }

        /// <summary>
        /// This is where you clean up any remaining resources used by your application before 
        /// the application itself is disposed of by TAF (TeachPendant Application Framework). 
        /// The method is called by TAF when the application is closed down.
        /// </summary>
        protected override void Dispose(bool disposing)
        {
            if (!IsDisposed)
            {
                try
                {
                    if (disposing)
                    {
                        //ToDo: Call the Dispose method of all FP SDK instances that may otherwise cause memory leak
                    }
                }
                finally
                {
                    base.Dispose(disposing);
                }
            }
        }

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            ABB.Robotics.DataBinding.SignalObject signalObject28 = new ABB.Robotics.DataBinding.SignalObject();
            ABB.Robotics.DataBinding.SignalObject signalObject29 = new ABB.Robotics.DataBinding.SignalObject();
            ABB.Robotics.DataBinding.SignalObject signalObject30 = new ABB.Robotics.DataBinding.SignalObject();
            ABB.Robotics.DataBinding.SignalObject signalObject31 = new ABB.Robotics.DataBinding.SignalObject();
            ABB.Robotics.DataBinding.SignalObject signalObject32 = new ABB.Robotics.DataBinding.SignalObject();
            ABB.Robotics.DataBinding.SignalObject signalObject33 = new ABB.Robotics.DataBinding.SignalObject();
            ABB.Robotics.DataBinding.SignalObject signalObject34 = new ABB.Robotics.DataBinding.SignalObject();
            ABB.Robotics.DataBinding.SignalObject signalObject35 = new ABB.Robotics.DataBinding.SignalObject();
            ABB.Robotics.DataBinding.SignalObject signalObject36 = new ABB.Robotics.DataBinding.SignalObject();
            this.signalBindingSource1 = new ABB.Robotics.DataBinding.SignalBindingSource();
            this.groupBox1 = new ABB.Robotics.Tps.Windows.Forms.GroupBox();
            this.label3 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.label1 = new System.Windows.Forms.Label();
            this.dataGrid1 = new System.Windows.Forms.DataGrid();
            this._btnOff = new ABB.Robotics.Tps.Windows.Forms.Button();
            this._btnOn = new ABB.Robotics.Tps.Windows.Forms.Button();
            this.dataGridTableStyle1 = new System.Windows.Forms.DataGridTableStyle();
            this.signalBindingSource1.BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.signalBindingSource1)).BeginInit();
            this.groupBox1.SuspendLayout();
            this.SuspendLayout();
            // 
            // signalBindingSource1
            // 
            this.signalBindingSource1.DataSource = typeof(ABB.Robotics.DataBinding.SignalObject);
            signalObject28.Name = "SignalA";
            signalObject29.Name = "SignalB";
            signalObject30.Name = "SignalC";
            signalObject31.Name = "SignalD";
            signalObject32.Name = "SignalE";
            signalObject33.Name = "SignalF";
            signalObject34.Name = "SignalG";
            signalObject35.Name = "SignalH";
            signalObject36.Name = "SignalI";
            this.signalBindingSource1.Signals.Add(signalObject28);
            this.signalBindingSource1.Signals.Add(signalObject29);
            this.signalBindingSource1.Signals.Add(signalObject30);
            this.signalBindingSource1.Signals.Add(signalObject31);
            this.signalBindingSource1.Signals.Add(signalObject32);
            this.signalBindingSource1.Signals.Add(signalObject33);
            this.signalBindingSource1.Signals.Add(signalObject34);
            this.signalBindingSource1.Signals.Add(signalObject35);
            this.signalBindingSource1.Signals.Add(signalObject36);
            // 
            // groupBox1
            // 
            this.groupBox1.Controls.Add(this.label3);
            this.groupBox1.Controls.Add(this.label2);
            this.groupBox1.Controls.Add(this.label1);
            this.groupBox1.Controls.Add(this.dataGrid1);
            this.groupBox1.Controls.Add(this._btnOff);
            this.groupBox1.Controls.Add(this._btnOn);
            this.groupBox1.HorizontalAlign = ABB.Robotics.Tps.Windows.Forms.HorAlign.Left;
            this.groupBox1.LineStyle = ABB.Robotics.Tps.Windows.Forms.LineStyle.SingleLine;
            this.groupBox1.Location = new System.Drawing.Point(17, 43);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new System.Drawing.Size(604, 327);
            this.groupBox1.Title = "Signals";
            this.groupBox1.VerticalAlign = ABB.Robotics.Tps.Windows.Forms.VerAlign.Center;
            // 
            // label3
            // 
            this.label3.Font = ABB.Robotics.Tps.Windows.Forms.TpsFont.Font12b;
            this.label3.Location = new System.Drawing.Point(398, 49);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(77, 20);
            this.label3.Text = "0";
            // 
            // label2
            // 
            this.label2.Font = ABB.Robotics.Tps.Windows.Forms.TpsFont.Font12b;
            this.label2.Location = new System.Drawing.Point(193, 49);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(169, 20);
            this.label2.Text = "Number of signals:";
            // 
            // label1
            // 
            this.label1.Font = ABB.Robotics.Tps.Windows.Forms.TpsFont.Font12b;
            this.label1.Location = new System.Drawing.Point(18, 127);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(154, 108);
            this.label1.Text = "Select the signal you want to modify and use the buttons to change the value";
            // 
            // dataGrid1
            // 
            this.dataGrid1.BackgroundColor = System.Drawing.Color.FromArgb(((int)(((byte)(128)))), ((int)(((byte)(128)))), ((int)(((byte)(128)))));
            this.dataGrid1.DataSource = this.signalBindingSource1;
            this.dataGrid1.Location = new System.Drawing.Point(193, 88);
            this.dataGrid1.Name = "dataGrid1";
            this.dataGrid1.Size = new System.Drawing.Size(282, 213);
            this.dataGrid1.TabIndex = 2;
            this.dataGrid1.TableStyles.Add(this.dataGridTableStyle1);
            // 
            // _btnOff
            // 
            this._btnOff.BackColor = System.Drawing.SystemColors.Control;
            this._btnOff.BackgroundImage = null;
            this._btnOff.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
            this._btnOff.Font = ABB.Robotics.Tps.Windows.Forms.TpsFont.Font12b;
            this._btnOff.Image = null;
            this._btnOff.Location = new System.Drawing.Point(524, 212);
            this._btnOff.Size = new System.Drawing.Size(77, 70);
            this._btnOff.TabIndex = 1;
            this._btnOff.Text = "0";
            this._btnOff.TextAlign = ABB.Robotics.Tps.Windows.Forms.ContentAlignmentABB.MiddleCenter;
            this._btnOff.Click += new System.EventHandler(this._btnOff_Click);
            // 
            // _btnOn
            // 
            this._btnOn.BackColor = System.Drawing.SystemColors.Control;
            this._btnOn.BackgroundImage = null;
            this._btnOn.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
            this._btnOn.Font = ABB.Robotics.Tps.Windows.Forms.TpsFont.Font12b;
            this._btnOn.Image = null;
            this._btnOn.Location = new System.Drawing.Point(524, 104);
            this._btnOn.Size = new System.Drawing.Size(77, 70);
            this._btnOn.TabIndex = 0;
            this._btnOn.Text = "1";
            this._btnOn.TextAlign = ABB.Robotics.Tps.Windows.Forms.ContentAlignmentABB.MiddleCenter;
            this._btnOn.Click += new System.EventHandler(this._btnOn_Click);
            // 
            // TpsViewIRC5SignalSample
            // 
            this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Inherit;
            this.Controls.Add(this.groupBox1);
            this.Size = new System.Drawing.Size(640, 390);
            this.Controls.SetChildIndex(this.groupBox1, 0);
            this.signalBindingSource1.EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.signalBindingSource1)).EndInit();
            this.groupBox1.ResumeLayout(false);
            this.ResumeLayout(false);


        }
        #endregion

        #region ITpsViewSetup Members

        /// <summary>
        /// This method is called by TAF when the control is closed down (before Dispose is called).
        /// </summary>	
        void ITpsViewSetup.Uninstall()
        {
            // TODO:  Add TpsViewIRC5SignalSample.Uninstall implementation
        }

        /// <summary>
        /// This method is called by TAF when the control is installed in the framework (after the constructor is called).
        /// </summary>				
        bool ITpsViewSetup.Install(object sender, object data)
        {
            // TODO:  Add TpsViewIRC5SignalSample.Install implementation
            return false;
        }

        #endregion

        #region ITpsViewActivation Members

        /// <summary>
        /// This method is called by TAF when the control goes from the active state to the passive state, 
        /// and is no longer visible in the client view. This happens when the user presses another application button 
        /// on the task bar, or closes the application. Normally, any subscriptions to controller events are removed here.
        /// </summary>				
        void ITpsViewActivation.Deactivate()
        {
            // TODO:  Add TpsViewIRC5SignalSample.Deactivate implementation
        }

        /// <summary>
        /// This method is called by TAF when the control goes from the passive state to the active state, 
        /// i.e. becomes visible in the client view. Normally, this is where subscriptions to controller events are set up.
        /// </summary>				
        void ITpsViewActivation.Activate()
        {
            // TODO:  Add TpsViewIRC5SignalSample.Activate implementation
        }

        #endregion


        private void _btnOn_Click(object sender, EventArgs e)
        {
            _tempObj = (ABB.Robotics.DataBinding.SignalObject)signalBindingSource1.Current; //selected signal in the signal binding source
            _tempObj.Value = 1;
        }

        private void _btnOff_Click(object sender, EventArgs e)
        {
            _tempObj = (ABB.Robotics.DataBinding.SignalObject)signalBindingSource1.Current; //selected signal in the signal binding source
            _tempObj.Value = 0;
        }

    }
}
